clearvars
close all
clc

%% Analisi statistica
alpha=1:0.01:50; % alpha [deg]

%% Hope
% CD
CDtsub=readtable('HOPE CD sub.csv'); % importare da file
CDtsuper=readtable('HOPE CD super.csv'); % importare da file

CDmsub = table2array(CDtsub); % trasformare in matrici
CDmsuper = table2array(CDtsuper); % trasformare in matrici

% CD subsonico
sizes=size(CDmsub);
for n=1:2:sizes(1,2)-1
    CDsub((n+1)/2) = spap2(10,6,CDmsub(:,n),CDmsub(:,n+1)); % fitting per CD
end

sizes=size(CDsub);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_CDsubval(:,n)=fnval(CDsub(n),alpha);
end

% CD supersonico
sizes=size(CDmsuper);
for n=1:2:sizes(1,2)-1
    CDsuper((n+1)/2) = spap2(10,6,CDmsuper(:,n),CDmsuper(:,n+1)); % fitting per CD
end

sizes=size(CDsuper);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_CDsuperval(:,n)=fnval(CDsuper(n),alpha);
end

% CL
CLsubt=readtable('HOPE CL sub.csv'); % importare da file
CLsupert=readtable('HOPE CL super.csv');

CLsubm = table2array(CLsubt);  % trasformare in matrici
CLsuperm = table2array(CLsupert);

% CL subsonico
sizes=size(CLsubm);
for n=1:2:sizes(1,2)-1
    CLsub((n+1)/2) = spap2(10,6,CLsubm(:,n),CLsubm(:,n+1)); % fitting per CL sub
end

sizes=size(CLsub);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_CLsubval(:,n)=fnval(CLsub(n),alpha);
end

% CL supersonico
sizes=size(CLsuperm);
for n=1:2:sizes(1,2)-1
    CLsuper((n+1)/2) = spap2(10,6,CLsuperm(:,n),CLsuperm(:,n+1)); % fitting per CL super
end

sizes=size(CLsuper);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_CLsuperval(:,n)=fnval(CLsuper(n),alpha);
end

% L/D
EFFsubt=readtable('HOPE EFF sub.csv'); % importare da file
EFFsupert=readtable('HOPE EFF super.csv');

EFFsubm = table2array(EFFsubt); % trasformare in matrici
EFFsuperm = table2array(EFFsupert);

% L/D subsonico
sizes=size(EFFsubm);
for n=1:2:sizes(1,2)-1
    EFFsub((n+1)/2) = spap2(10,6,EFFsubm(:,n),EFFsubm(:,n+1));  % fitting per L/D
end

sizes=size(EFFsub);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_EFFsubval(:,n)=fnval(EFFsub(n),alpha);
end

% L/D supersonico
sizes=size(EFFsuperm);
for n=1:2:sizes(1,2)-1
    EFFsuper((n+1)/2) = spap2(10,6,EFFsuperm(:,n),EFFsuperm(:,n+1)); % fitting per L/D
end

sizes=size(EFFsuper);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hope_EFFsuperval(:,n)=fnval(EFFsuper(n),alpha);
end

%% Horus
%   PER CDsub NON SI HA M=0.9 PERCHè COLONNA SALTATA, MA SI HANNO CL L/D
%   QUINDI ATTENZIONE ALLA LUNGHEZZA DEI VETTORI

% CD
CDtss=readtable('Saenger Horus CD sub.csv'); % importare da file
CDthy=readtable('Saenger Horus CD super.csv'); % importare da file


CDmss = table2array(CDtss); % trasformare in matrici
CDmhy = table2array(CDthy); % trasformare in matrici


% CD subsonico supersonico
sizes=size(CDmss);
for n=1:2:sizes(1,2)-1
    CDss((n+1)/2) = spap2(10,6,CDmss(:,n),CDmss(:,n+1)); % fitting per CD
end

sizes=size(CDss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Horus_CDssval(:,n)=fnval(CDss(n),alpha);
end

% CD iperpersonico
sizes=size(CDmhy);
for n=1:2:sizes(1,2)-1
    CDhy((n+1)/2) = spap2(10,6,CDmhy(:,n),CDmhy(:,n+1)); % fitting per CD
end

sizes=size(CDhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Horus_CDhyval(:,n)=fnval(CDhy(n),alpha);
end

% CL
CLsst=readtable('Saenger Horus CL sub.csv'); % importare da file
CLhyt=readtable('Saenger Horus CL super.csv');

CLssm = table2array(CLsst); % trasformare in matrici
CLhym = table2array(CLhyt);

% CL subsonico supersonico
sizes=size(CLssm);
for n=1:2:sizes(1,2)-1
    CLss((n+1)/2) = spap2(10,6,CLssm(:,n),CLssm(:,n+1)); % fitting per CL
end

sizes=size(CLss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Horus_CLssval(:,n)=fnval(CLss(n),alpha);
end


% CL iperpersonico
sizes=size(CLhym);
for n=1:2:sizes(1,2)-1
    CLhy((n+1)/2) = spap2(10,6,CLhym(:,n),CLhym(:,n+1)); % fitting per CL iper
end

sizes=size(CLhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Horus_CLhyval(:,n)=fnval(CLhy(n),alpha);
end

% L/D Efficienza
EFFsst=readtable('Saenger Horus EFF sub.csv'); % importare da file
EFFhyt=readtable('Saenger Horus EFF super.csv');

EFFssm = table2array(EFFsst); % trasformare in matrici
EFFhym = table2array(EFFhyt);

% L/D subsonico supersonico
sizes=size(EFFssm);
for n=1:2:sizes(1,2)-1
    EFFss((n+1)/2) = spap2(10,6,EFFssm(:,n),EFFssm(:,n+1)); % fitting per L/D
end

sizes=size(EFFss);
for n=1:sizes(1,2)  %valori in funzione di alpha
    Horus_EFFssval(:,n)=fnval(EFFss(n),alpha);
end

% L/D ipersonico
sizes=size(EFFhym);
for n=1:2:sizes(1,2)-1
    EFFhy((n+1)/2) = spap2(10,6,EFFhym(:,n),EFFhym(:,n+1)); % fitting per L/D
end

sizes=size(EFFhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Horus_EFFhyval(:,n)=fnval(EFFhy(n),alpha);
end

%% Saenger
% CD
CDtss=readtable('Saenger CD sub.csv'); % importare da file
CDthy=readtable('Saenger CD super.csv'); % importare da file

CDmss = table2array(CDtss); % trasformare in matrici
CDmhy = table2array(CDthy); % trasformare in matrici

% CD subsonico supersonico
sizes=size(CDmss);
for n=1:2:sizes(1,2)-1
    CDss((n+1)/2) = spap2(10,6,CDmss(:,n),CDmss(:,n+1)); % fitting per CD
end

sizes=size(CDss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_CDssval(:,n)=fnval(CDss(n),alpha);
end

% CD iperpersonico
sizes=size(CDmhy);
for n=1:2:sizes(1,2)-1
    CDhy((n+1)/2) = spap2(10,6,CDmhy(:,n),CDmhy(:,n+1)); % fitting per CD
end

sizes=size(CDhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_CDhyval(:,n)=fnval(CDhy(n),alpha);
end

% CL
CLsst=readtable('Saenger CL sub.csv'); % importare da file
CLhyt=readtable('Saenger CL super.csv');

CLssm = table2array(CLsst); % trasformare in matrici
CLhym = table2array(CLhyt);

% CL subsonico supersonico
sizes=size(CLssm);
for n=1:2:sizes(1,2)-1
    CLss((n+1)/2) = spap2(10,6,CLssm(:,n),CLssm(:,n+1)); % fitting per CL
end

sizes=size(CLss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_CLssval(:,n)=fnval(CLss(n),alpha);
end

% CL iperpersonico
sizes=size(CLhym);
for n=1:2:sizes(1,2)-1
    CLhy((n+1)/2) = spap2(10,6,CLhym(:,n),CLhym(:,n+1)); % fitting per CL iper
end

sizes=size(CLhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_CLhyval(:,n)=fnval(CLhy(n),alpha);
end

% L/D Efficienza
EFFsst=readtable('Saenger EFF sub.csv'); % importare da file
EFFhyt=readtable('Saenger EFF super.csv');

EFFssm = table2array(EFFsst); % trasformare in matrici
EFFhym = table2array(EFFhyt);

% L/D subsonico supersonico
sizes=size(EFFssm);
for n=1:2:sizes(1,2)-1
    EFFss((n+1)/2) = spap2(10,6,EFFssm(:,n),EFFssm(:,n+1)); % fitting per L/D
end

sizes=size(EFFss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_EFFssval(:,n)=fnval(EFFss(n),alpha);
end

% L/D ipersonico
sizes=size(EFFhym);
for n=1:2:sizes(1,2)-1
    EFFhy((n+1)/2) = spap2(10,6,EFFhym(:,n),EFFhym(:,n+1)); % fitting per L/D
end

sizes=size(EFFhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Saenger_EFFhyval(:,n)=fnval(EFFhy(n),alpha);
end

%% Shuttle
% CD
CDsubt=readtable('Shuttle CD sub.csv');  % importare da file
CDsupert=readtable('Shuttle CD super.csv');
CDipert=readtable('Shuttle CD iper.csv');

CDsub = table2array(CDsubt); % trasformare in matrici
CDsuper = table2array(CDsupert);
CDiper_matrix = table2array(CDipert);

Shuttle_alpha=-10:0.01:25; % alpha per sub & super
sCD=Shuttle_alpha'; % CD per sub & super
m=2; % contatore CD sub & super

sizes=size(CDsub);
for n=1:2:sizes(1,2)-1 % fitting CD sub
    sCD(:,m)=spline(CDsub(:,n),CDsub(:,n+1),sCD(:,1));
    m=m+1;
end

sizes=size(CDsuper);
CDlegendsuper={'M=1.1','M=1.5','M=2','M=3','M=4'}; % Mach di volo

for n=1:2:sizes(1,2)-1 % fitting CD super
    sCD(:,m)=spline(CDsuper(:,n),CDsuper(:,n+1),sCD(:,1));
    m=m+1;
end

Shuttle_alphaiper=-10:0.01:40; % alpha per iper
sCDiper=Shuttle_alphaiper'; % CD per iper
m=2; % contatore CD iper

sizes=size(CDiper_matrix);
for n=1:2:sizes(1,2)-1 % fitting CD iper
    sCDiper(:,m)=spline(CDiper_matrix(:,n),CDiper_matrix(:,n+1),sCDiper(:,1));
    m=m+1;
end

m=0; % reset
n=0;
t=0;

% CL
CLsubt=readtable('Shuttle CL sub.csv'); % importare da file
CLsupert=readtable('Shuttle CL super.csv');
CLipert=readtable('Shuttle CL iper.csv');

CLsub = table2array(CLsubt); % trasformare in matrici
CLsuper = table2array(CLsupert);
CLiper_matrix = table2array(CLipert);

sCL=Shuttle_alpha'; % CL per sub & super
m=2; % contatore CL sub & super

sizes=size(CLsub);
s=isnan(CLsub);
s=sum(s);

for n=1:2:sizes(1,2)-1 % fitting CL sub
    %         CL(:,m)=spline(CLsub(:,n),CLsub(:,n+1),CL(:,1));
    p=polyfit(CLsub(1:sizes(1,1)-s(1,n),n),CLsub(1:sizes(1,1)-s(1,n),n+1),3);
    sCL(:,m)=polyval(p,sCL(:,1));
    m=m+1;
end

sizes=size(CLsuper);
s=isnan(CLsuper);
s=sum(s);

for n=1:2:sizes(1,2)-1 % fitting CL super
    %      CL(:,m)=spline(CLsuper(:,n),CLsuper(:,n+1),CL(:,1));
    p=polyfit(CLsuper(1:sizes(1,1)-s(1,n),n),CLsuper(1:sizes(1,1)-s(1,n),n+1),3);
    sCL(:,m)=polyval(p,sCL(:,1));
    m=m+1;
end

Shuttle_alphaiper=-10:0.01:40; % alpha per iper
sCLiper=Shuttle_alphaiper'; % CL per iper
m=2; % contatore CL iper

sizes=size(CLiper_matrix);
s=isnan(CLiper_matrix);
s=sum(s);

for n=1:2:sizes(1,2)-1 % fitting CD iper
    %     CLiper(:,m)=spline(CLiper_matrix(:,n),CLiper_matrix(:,n+1),CLiper(:,1));
    p=polyfit(CLiper_matrix(1:sizes(1,1)-s(1,n),n),CLiper_matrix(1:sizes(1,1)-s(1,n),n+1),3);
    sCLiper(:,m)=polyval(p,sCLiper(:,1));
    m=m+1;
end

m=0; % reset
n=0;
t=0;

% L/D Efficienza
EFFsubt=readtable('Shuttle EFF sub.csv'); % importare da file
EFFsupert=readtable('Shuttle EFF super.csv');
EFFipert=readtable('Shuttle EFF iper.csv');

EFFsub = table2array(EFFsubt); % trasformare in matrici
EFFsuper = table2array(EFFsupert);
EFFiper_matrix = table2array(EFFipert);

sEFF=Shuttle_alpha'; % L/D per sub & super
m=2;

sEFF(:,1)=sCL(:,1); % Calcolo L/D con divisione
sEFF=[sEFF sCL(:,2:end)./sCD(:,2:end)];

Shuttle_alphaiper=-10:0.01:40; % alpha per iper
sEFFiper=Shuttle_alphaiper'; % CL per iper
m=2; % contatore CL iper

sEFFiper(:,1)=sEFFiper(:,1); % Calcolo L/D con divisione
sEFFiper=[sEFFiper sCLiper(:,2:end)./sCDiper(:,2:end)];

% Valori Finali
Shuttle_alpha=sCD(:, 1);
Shuttle_alpha_iper=sCDiper(:,1);

t=find(Shuttle_alpha==1);

Shuttle_CD=sCD(t:end, 2:end);     % prendo solo i valori di CD per alpha>1, come per tutti i tipi di velivoli
Shuttle_CD=[Shuttle_CD; zeros(size(alpha,2)-size(Shuttle_CD,1),size(Shuttle_CD,2))]; % aggiungo le righe per arrivare allo stesso numero degli altri velivoli

%procedo allo stesso modo con CL e L/D
Shuttle_CDiper=sCDiper(t:end, 2:end);   % % prendo solo i valori di L/D per alpha>1, come per tutti i tipi di velivoli
Shuttle_CDiper=[Shuttle_CDiper; zeros(size(alpha,2)-size(Shuttle_CDiper,1),size(Shuttle_CDiper,2))]; % aggiungo le righe per arrivare allo stesso numero degli altri velivoli

Shuttle_CL=sCL(t:end, 2:end);
Shuttle_CL=[Shuttle_CL; zeros(size(alpha,2)-size(Shuttle_CL,1),size(Shuttle_CL,2))];

Shuttle_CLiper=sCLiper(t:end, 2:end);
Shuttle_CLiper=[Shuttle_CLiper; zeros(size(alpha,2)-size(Shuttle_CLiper,1),size(Shuttle_CLiper,2))];

Shuttle_EFF=sEFF(t:end, 2:end);
Shuttle_EFF=[Shuttle_EFF; zeros(size(alpha,2)-size(Shuttle_EFF,1),size(Shuttle_EFF,2))];

Shuttle_EFFiper=sEFFiper(t:end, 2:end);
Shuttle_EFFiper=[Shuttle_EFFiper; zeros(size(alpha,2)-size(Shuttle_EFFiper,1),size(Shuttle_EFFiper,2))];

%% X-33
% CD
CDt=readtable('X33 CD.csv'); % importare da file
CDm = table2array(CDt); % trasformare in matrici

sizes=size(CDm);
for n=1:2:sizes(1,2)-1
    CD((n+1)/2) = spap2(10,6,CDm(:,n),CDm(:,n+1)); % fitting per CD
end

sizes=size(CD); %valori in funzione di alpha
for n=1:sizes(1,2)
    X33_CDval(:,n)=fnval(CD(n),alpha);
end

% CL
CLt=readtable('X33 CL.csv'); % importare da file
CLm = table2array(CLt); % trasformare in matrici

sizes=size(CLm);
for n=1:2:sizes(1,2)-1
    CL((n+1)/2) = spap2(10,6,CLm(:,n),CLm(:,n+1)); % fitting per CL    hold on
end

sizes=size(CL);
for n=1:sizes(1,2) %valori in funzione di alpha
    X33_CLval(:,n)=fnval(CL(n),alpha);
end

% L/D Efficienza
EFFt=readtable('X33 EFF.csv'); % importare da file
EFFm = table2array(EFFt); % trasformare in matrici

sizes=size(EFFm);
for n=1:2:sizes(1,2)-1
    EFF((n+1)/2) = spap2(10,6,EFFm(:,n),EFFm(:,n+1)); % fitting per CL
end

sizes=size(EFF);
for n=1:sizes(1,2) %valori in funzione di alpha
    X33_EFFval(:,n)=fnval(EFF(n),alpha);
end

%% X-34
% CD
CDt=readtable('X34 CD.csv'); % importare da file
CDm = table2array(CDt); % trasformare in matrici

sizes=size(CDm);
for n=1:2:sizes(1,2)-1
    CD((n+1)/2) = spap2(10,6,CDm(:,n),CDm(:,n+1)); % fitting per CD
end

sizes=size(CD);
for n=1:sizes(1,2) %valori in funzione di alpha
    X34_CDval(:,n)=fnval(CD(n),alpha);
end

% CL
CLt=readtable('X34 CL.csv'); % importare da file
CLm = table2array(CLt); % trasformare in matrici

sizes=size(CLm);
for n=1:2:sizes(1,2)-1
    CL((n+1)/2) = spap2(10,6,CLm(:,n),CLm(:,n+1)); % fitting per CL
end

sizes=size(CL);
for n=1:sizes(1,2) %valori in funzione di alpha
    X34_CLval(:,n)=fnval(CL(n),alpha);
end

% L/D Efficienza
EFFt=readtable('X34 EFF.csv'); % importare da file
EFFm = table2array(EFFt); % trasformare in matrici

sizes=size(EFFm);
for n=1:2:sizes(1,2)-1
    EFF((n+1)/2) = spap2(10,6,EFFm(:,n),EFFm(:,n+1)); % fitting per CL
end

sizes=size(EFF);
for n=1:sizes(1,2) %valori in funzione di alpha
    X34_EFFval(:,n)=fnval(EFF(n),alpha);
end

%% Hermes
% CD
CDtss=readtable('HERMES CD SS.csv'); % importare da file
CDthy=readtable('HERMES CD HY.csv'); % importare da file

CDmss = table2array(CDtss); % trasformare in matrici
CDmhy = table2array(CDthy); % trasformare in matrici

% CD subsonico supersonico
sizes=size(CDmss);
for n=1:2:sizes(1,2)-1
    CDss((n+1)/2) = spap2(10,6,CDmss(:,n),CDmss(:,n+1)); % fitting per CD
end

sizes=size(CDss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_CDssval(:,n)=fnval(CDss(n),alpha);
end

% CD iperpersonico
sizes=size(CDmhy);
for n=1:2:sizes(1,2)-1
    CDhy((n+1)/2) = spap2(10,6,CDmhy(:,n),CDmhy(:,n+1)); % fitting per CD
end

sizes=size(CDhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_CDhyval(:,n)=fnval(CDhy(n),alpha);
end

% CL
CLsst=readtable('HERMES CL SS.csv'); % importare da file
CLhyt=readtable('HERMES CL HY.csv');

CLssm = table2array(CLsst); % trasformare in matrici
CLhym = table2array(CLhyt);

% CL subsonico supersonico
sizes=size(CLssm);
for n=1:2:sizes(1,2)-1
    CLss((n+1)/2) = spap2(10,6,CLssm(:,n),CLssm(:,n+1)); % fitting per CL
end

sizes=size(CLss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_CLssval(:,n)=fnval(CLss(n),alpha);
end

% CL iperpersonico
sizes=size(CLhym);
for n=1:2:sizes(1,2)-1
    CLhy((n+1)/2) = spap2(10,6,CLhym(:,n),CLhym(:,n+1)); % fitting per CL iper
end

sizes=size(CLhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_CLhyval(:,n)=fnval(CLhy(n),alpha);
end

% L/D Efficienza
EFFsst=readtable('HERMES EFF SS.csv'); % importare da file
EFFhyt=readtable('HERMES EFF HY.csv');

EFFssm = table2array(EFFsst); % trasformare in matrici
EFFhym = table2array(EFFhyt);

% L/D subsonico supersonico
sizes=size(EFFssm);
for n=1:2:sizes(1,2)-1
    EFFss((n+1)/2) = spap2(10,6,EFFssm(:,n),EFFssm(:,n+1)); % fitting per L/D
end

sizes=size(EFFss);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_EFFssval(:,n)=fnval(EFFss(n),alpha);
end

% L/D ipersonico
sizes=size(EFFhym);
for n=1:2:sizes(1,2)-1
    EFFhy((n+1)/2) = spap2(10,6,EFFhym(:,n),EFFhym(:,n+1)); % fitting per L/D
end

sizes=size(EFFhy);
for n=1:sizes(1,2) %valori in funzione di alpha
    Hermes_EFFhyval(:,n)=fnval(EFFhy(n),alpha);
end

%% Valori in funzione del Mach
% legenda: z=zero; u=1; d=10; v=venti; t=30;
% M=0.2

z2_CD=[Hope_CDsubval(:,1) Horus_CDssval(:,1) Saenger_CDssval(:,1)];
s=0;
for n=1:size(z2_CD,1)    % ciclo per il valore medio
    for m=1:size(z2_CD,2)
        t=any(z2_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z2_CDm(n,1)=sum(z2_CD(n,:))/s;   % media
    s=0;
end

z2_CL=[Hope_CLsubval(:,1) Horus_CLssval(:,1) Saenger_CLssval(:,1)];
s=0;
for n=1:size(z2_CL,1)     % ciclo per il valore medio
    for m=1:size(z2_CL,2)
        t=any(z2_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z2_CLm(n,1)=sum(z2_CL(n,:))/s;   % media
    s=0;
end

z2_EFF=[Hope_EFFsubval(:,1) Horus_EFFssval(:,1) Saenger_EFFssval(:,1)];
s=0;
for n=1:size(z2_EFF,1)        % ciclo per il valore medio
    for m=1:size(z2_EFF,2)
        t=any(z2_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z2_EFFm(n,1)=sum(z2_EFF(n,:))/s;   % media
    s=0;
end

% M=0.25

z25_CD=[Shuttle_CD(:,1)];
for n=1:size(z25_CD,1)    % ciclo per il valore medio
    for m=1:size(z25_CD,2)
        t=any(z25_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z25_CDm(n,1)=sum(z25_CD(n,:))/s;   % media
    s=0;
end

z25_CL=[Shuttle_CL(:,1)];
s=0;
for n=1:size(z25_CL,1)     % ciclo per il valore medio
    for m=1:size(z25_CL,2)
        t=any(z25_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z25_CLm(n,1)=sum(z25_CL(n,:))/s;   % media
    s=0;
end

z25_EFF=[Shuttle_EFF(:,1)];
s=0;
for n=1:size(z25_EFF,1)        % ciclo per il valore medio
    for m=1:size(z25_EFF,2)
        t=any(z25_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z25_EFFm(n,1)=sum(z25_EFF(n,:))/s;   % media
    s=0;
end

% M=0.3

z3_CD=[Hermes_CDssval(:,1)];
s=0;
for n=1:size(z3_CD,1)    % ciclo per il valore medio
    for m=1:size(z3_CD,2)
        t=any(z3_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z3_CDm(n,1)=sum(z3_CD(n,:))/s;   % media
    s=0;
end

z3_CL=[Hermes_CLssval(:,1)];
s=0;
for n=1:size(z3_CL,1)     % ciclo per il valore medio
    for m=1:size(z3_CL,2)
        t=any(z3_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z3_CLm(n,1)=sum(z3_CL(n,:))/s;   % media
    s=0;
end

z3_EFF=[Hermes_EFFssval(:,1)];
s=0;
for n=1:size(z3_EFF,1)        % ciclo per il valore medio
    for m=1:size(z3_EFF,2)
        t=any(z3_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z3_EFFm(n,1)=sum(z3_EFF(n,:))/s;   % media
    s=0;
end

% M=0.4

z4_CD=[Hope_CDsubval(:,2) X34_CDval(:,1)];
s=0;
for n=1:size(z4_CD,1)    % ciclo per il valore medio
    for m=1:size(z4_CD,2)
        t=any(z4_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z4_CDm(n,1)=sum(z2_CD(n,:))/s;   % media
    s=0;
end

z4_CL=[Hope_CLsubval(:,2) X34_CLval(:,1)];
s=0;
for n=1:size(z4_CL,1)     % ciclo per il valore medio
    for m=1:size(z4_CL,2)
        t=any(z4_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z4_CLm(n,1)=sum(z4_CL(n,:))/s;   % media
    s=0;
end


z4_EFF=[Hope_EFFsubval(:,2) X34_EFFval(:,1)];
s=0;
for n=1:size(z4_EFF,1)        % ciclo per il valore medio
    for m=1:size(z4_EFF,2)
        t=any(z4_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z4_EFFm(n,1)=sum(z4_EFF(n,:))/s;   % media
    s=0;
end

% M=0.5

z5_CD=[Horus_CDssval(:,2) Saenger_CDssval(:,2)];
s=0;
for n=1:size(z5_CD,1)    % ciclo per il valore medio
    for m=1:size(z5_CD,2)
        t=any(z5_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z5_CDm(n,1)=sum(z5_CD(n,:))/s;   % media
    s=0;
end

z5_CL=[Horus_CLssval(:,2) Saenger_CLssval(:,2)];
s=0;
for n=1:size(z5_CL,1)    % ciclo per il valore medio
    for m=1:size(z5_CL,2)
        t=any(z5_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z5_CLm(n,1)=sum(z5_CL(n,:))/s;   % media
    s=0;
end

z5_EFF=[Horus_EFFssval(:,2) Saenger_EFFssval(:,2)];
s=0;
for n=1:size(z5_EFF,1)    % ciclo per il valore medio
    for m=1:size(z5_EFF,2)
        t=any(z5_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z5_EFFm(n,1)=sum(z5_EFF(n,:))/s;   % media
    s=0;
end

% M=0.6

z6_CD=[Hope_CDsubval(:,3) Shuttle_CD(:,2)];
s=0;
for n=1:size(z6_CD,1)    % ciclo per il valore medio
    for m=1:size(z6_CD,2)
        t=any(z6_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z6_CDm(n,1)=sum(z6_CD(n,:))/s;   % media
    s=0;
end

z6_CL=[Hope_CLsubval(:,3) Shuttle_CL(:,2)];
s=0;
for n=1:size(z6_CL,1)    % ciclo per il valore medio
    for m=1:size(z6_CL,2)
        t=any(z6_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z6_CLm(n,1)=sum(z6_CL(n,:))/s;   % media
    s=0;
end

z6_EFF=[Hope_EFFsubval(:,3) Shuttle_EFF(:,2)];
s=0;
for n=1:size(z6_EFF,1)    % ciclo per il valore medio
    for m=1:size(z6_EFF,2)
        t=any(z6_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z6_EFFm(n,1)=sum(z6_EFF(n,:))/s;   % media
    s=0;
end

% M=0.7

z7_CD=[Hermes_CDssval(:,2)];
s=0;
for n=1:size(z7_CD,1)    % ciclo per il valore medio
    for m=1:size(z7_CD,2)
        t=any(z7_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z7_CDm(n,1)=sum(z7_CD(n,:))/s;   % media
    s=0;
end

z7_CL=[Hermes_CLssval(:,2)];
s=0;
for n=1:size(z7_CL,1)    % ciclo per il valore medio
    for m=1:size(z7_CL,2)
        t=any(z7_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z7_CLm(n,1)=sum(z7_CL(n,:))/s;   % media
    s=0;
end

z7_EFF=[Hermes_EFFssval(:,2)];
s=0;
for n=1:size(z7_EFF,1)    % ciclo per il valore medio
    for m=1:size(z7_EFF,2)
        t=any(z7_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z7_EFFm(n,1)=sum(z7_EFF(n,:))/s;   % media
    s=0;
end

% M=0.8

z8_CD=[Hope_CDsubval(:,4) Horus_CDssval(:,3) Saenger_CDssval(:,3) Shuttle_CD(:,4) X34_CDval(:,2)];
s=0;
for n=1:size(z8_CD,1)    % ciclo per il valore medio
    for m=1:size(z8_CD,2)
        t=any(z8_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z8_CDm(n,1)=sum(z8_CD(n,:))/s;   % media
    s=0;
end

z8_CL=[Hope_CLsubval(:,4) Horus_CLssval(:,3) Saenger_CLssval(:,3) Shuttle_CL(:,4) X34_CLval(:,2)];
s=0;
for n=1:size(z8_CL,1)    % ciclo per il valore medio
    for m=1:size(z8_CL,2)
        t=any(z8_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z8_CLm(n,1)=sum(z8_CL(n,:))/s;   % media
    s=0;
end

z8_EFF=[Hope_EFFsubval(:,4) Horus_EFFssval(:,3) Saenger_EFFssval(:,3) Shuttle_EFF(:,4) X34_EFFval(:,2)];
s=0;
for n=1:size(z8_EFF,1)    % ciclo per il valore medio
    for m=1:size(z8_EFF,2)
        t=any(z8_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z8_EFFm(n,1)=sum(z8_EFF(n,:))/s;   % media
    s=0;
end

% M=0.9

z9_CD=[Hope_CDsubval(:,5) Saenger_CDssval(:,4) X34_CDval(:,3) Hermes_CDssval(:,3)];
s=0;
for n=1:size(z9_CD,1)    % ciclo per il valore medio
    for m=1:size(z9_CD,2)
        t=any(z9_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z9_CDm(n,1)=sum(z9_CD(n,:))/s;   % media
    s=0;
end

z9_CL=[Hope_CLsubval(:,5) Horus_CLssval(:,4) Saenger_CLssval(:,4)  X34_CLval(:,3) Hermes_CLssval(:,3)];
s=0;
for n=1:size(z9_CL,1)    % ciclo per il valore medio
    for m=1:size(z9_CL,2)
        t=any(z9_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z9_CLm(n,1)=sum(z9_CL(n,:))/s;   % media
    s=0;
end

z9_EFF=[Hope_EFFsubval(:,5) Horus_EFFssval(:,4) Saenger_EFFssval(:,4)  X34_EFFval(:,3) Hermes_EFFssval(:,3)];
s=0;
for n=1:size(z9_EFF,1)    % ciclo per il valore medio
    for m=1:size(z9_EFF,2)
        t=any(z9_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z9_EFFm(n,1)=sum(z9_EFF(n,:))/s;   % media
    s=0;
end

% M=0.92

z92_CD=[Shuttle_CD(:,4)];
s=0;
for n=1:size(z92_CD,1)    % ciclo per il valore medio
    for m=1:size(z92_CD,2)
        t=any(z92_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z92_CDm(n,1)=sum(z92_CD(n,:))/s;   % media
    s=0;
end

z92_CL=[Shuttle_CL(:,4)];
s=0;
for n=1:size(z92_CL,1)    % ciclo per il valore medio
    for m=1:size(z92_CL,2)
        t=any(z92_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z92_CLm(n,1)=sum(z92_CL(n,:))/s;   % media
    s=0;
end

z92_EFF=[Shuttle_EFF(:,4)];
s=0;
for n=1:size(z92_EFF,1)    % ciclo per il valore medio
    for m=1:size(z92_EFF,2)
        t=any(z92_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z92_EFFm(n,1)=sum(z92_EFF(n,:))/s;   % media
    s=0;
end

% M=0.95

z95_CD=[ Horus_CDssval(:,4) Saenger_CDssval(:,5)];
s=0;
for n=1:size(z95_CD,1)    % ciclo per il valore medio
    for m=1:size(z95_CD,2)
        t=any(z95_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z95_CDm(n,1)=sum(z95_CD(n,:))/s;   % media
    s=0;
end

z95_CL=[Horus_CLssval(:,5) Saenger_CLssval(:,5)];
s=0;
for n=1:size(z95_CL,1)    % ciclo per il valore medio
    for m=1:size(z95_CL,2)
        t=any(z95_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z95_CLm(n,1)=sum(z95_CL(n,:))/s;   % media
    s=0;
end

z95_EFF=[Horus_EFFssval(:,5) Saenger_EFFssval(:,5)];
s=0;
for n=1:size(z95_EFF,1)    % ciclo per il valore medio
    for m=1:size(z95_EFF,2)
        t=any(z95_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z95_EFFm(n,1)=sum(z95_EFF(n,:))/s;   % media
    s=0;
end

% M=0.98

z98_CD=[Shuttle_CD(:,5)];
s=0;
for n=1:size(z98_CD,1)    % ciclo per il valore medio
    for m=1:size(z98_CD,2)
        t=any(z98_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z98_CDm(n,1)=sum(z98_CD(n,:))/s;   % media
    s=0;
end

z98_CL=[Shuttle_CL(:,5)];
s=0;
for n=1:size(z98_CL,1)    % ciclo per il valore medio
    for m=1:size(z98_CL,2)
        t=any(z98_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z98_CLm(n,1)=sum(z98_CL(n,:))/s;   % media
    s=0;
end

z98_EFF=[Shuttle_EFF(:,5)];
s=0;
for n=1:size(z98_EFF,1)    % ciclo per il valore medio
    for m=1:size(z98_EFF,2)
        t=any(z98_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    z98_EFFm(n,1)=sum(z98_EFF(n,:))/s;   % media
    s=0;
end

% Subsonico
sublegenda={'M=0.2','M=0.25','M=0.3','M=0.4','M=0.5','M=0.6','M=0.7','M=0.8','M=0.9','M=0.95','M=0.98'};   % Mach di volo

%CL
CLsubmedio=[z2_CLm z25_CLm z3_CLm z4_CLm z5_CLm z6_CLm z7_CLm z8_CLm z9_CLm z95_CLm z98_CLm];

for n=1:size(CLsubmedio,2)
    CLsubspline(n) = spap2(4,3,alpha,CLsubmedio(:,n));                          % fitting per CD
    hold on
end

% CD
CDsubmedio=[z2_CDm z25_CDm z3_CDm z4_CDm z5_CDm z6_CDm z7_CDm z8_CDm z9_CDm z95_CDm z98_CDm];

for n=1:size(CDsubmedio,2)
    CDsubspline(n) = spap2(4,3,alpha,CDsubmedio(:,n));                          % fitting per CD
    hold on
end

% L/D
EFFsubmedio=[z2_EFFm z25_EFFm z3_EFFm z4_EFFm z5_EFFm z6_EFFm z7_EFFm z8_EFFm z9_EFFm z95_EFFm z98_EFFm];

for n=1:size(EFFsubmedio,2)
    EFFsubspline(n) = spap2(4,3,alpha, EFFsubmedio(:,n));                          % fitting per L/D
    hold on
end

% M=1.05

u05_CD=X34_CDval(:,4);
s=0;
for n=1:size(u05_CD,1)    % ciclo per il valore medio
    for m=1:size(u05_CD,2)
        t=any(u05_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u05_CDm(n,1)=sum(u05_CD(n,:))/s;   % media
    s=0;
end

u05_CL=X34_CLval(:,4);
for n=1:size(u05_CL,1)    % ciclo per il valore medio
    for m=1:size(u05_CL,2)
        t=any(u05_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u05_CLm(n,1)=sum(u05_CL(n,:))/s;   % media
    s=0;
end

u05_EFF=X34_EFFval(:,4);
for n=1:size(u05_EFF,1)    % ciclo per il valore medio
    for m=1:size(u05_EFF,2)
        t=any(u05_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u05_EFFm(n,1)=sum(u05_EFF(n,:))/s;   % media
    s=0;
end

% M=1.1

u1_CD=[Hope_CDsuperval(:,1) Horus_CDssval(:,5) Saenger_CDssval(:,6) Shuttle_CD(:,6) Hermes_CDssval(:,4)];
s=0;
for n=1:size(u1_CD,1)    % ciclo per il valore medio
    for m=1:size(u1_CD,2)
        t=any(u1_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u1_CDm(n,1)=sum(u1_CD(n,:))/s;   % media
    s=0;
end

u1_CL=[Hope_CLsuperval(:,1) Horus_CLssval(:,6) Saenger_CLssval(:,6)  Shuttle_CL(:,6) Hermes_CLssval(:,4)];
s=0;
for n=1:size(u1_CL,1)    % ciclo per il valore medio
    for m=1:size(u1_CL,2)
        t=any(u1_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u1_CLm(n,1)=sum(u1_CL(n,:))/s;   % media
    s=0;
end

u1_EFF=[Hope_EFFsuperval(:,1) Horus_EFFssval(:,6) Saenger_EFFssval(:,6)  Shuttle_EFF(:,6) Hermes_EFFssval(:,4)];
s=0;
for n=1:size(u1_EFF,1)    % ciclo per il valore medio
    for m=1:size(u1_EFF,2)
        t=any(u1_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u1_EFFm(n,1)=sum(u1_EFF(n,:))/s;   % media
    s=0;
end

% M=1.2

u2_CD=[Hope_CDsuperval(:,2)];
for n=1:size(u2_CD,1)    % ciclo per il valore medio
    for m=1:size(u2_CD,2)
        t=any(u2_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u2_CDm(n,1)=sum(u2_CD(n,:))/s;   % media
    s=0;
end

u2_CL=[Hope_CLsuperval(:,2)];
s=0;
for n=1:size(u2_CL,1)    % ciclo per il valore medio
    for m=1:size(u2_CL,2)
        t=any(u2_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u2_CLm(n,1)=sum(u2_CL(n,:))/s;   % media
    s=0;
end

u2_EFF=[Hope_EFFsuperval(:,2)];
s=0;
for n=1:size(u2_EFF,1)    % ciclo per il valore medio
    for m=1:size(u2_EFF,2)
        t=any(u2_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u2_EFFm(n,1)=sum(u2_EFF(n,:))/s;   % media
    s=0;
end

% M=1.3

u3_CD=[Horus_CDssval(:,6) Saenger_CDssval(:,7)];  %Horus saltata riga, vedi file origine
s=0;
for n=1:size(u3_CD,1)    % ciclo per il valore medio
    for m=1:size(u3_CD,2)
        t=any(u3_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u3_CDm(n,1)=sum(u3_CD(n,:))/s;   % media
    s=0;
end

u3_CL=[Horus_CLssval(:,7) Saenger_CDssval(:,7)];
s=0;
for n=1:size(u3_CL,1)    % ciclo per il valore medio
    for m=1:size(u3_CL,2)
        t=any(u3_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u3_CLm(n,1)=sum(u3_CL(n,:))/s;   % media
    s=0;
end

u3_EFF=[Horus_EFFssval(:,7) Saenger_EFFssval(:,7)];
s=0;
for n=1:size(u3_EFF,1)    % ciclo per il valore medio
    for m=1:size(u3_EFF,2)
        t=any(u3_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u3_EFFm(n,1)=sum(u3_EFF(n,:))/s;   % media
    s=0;
end

% M=1.5

u5_CD=[Hope_CDsuperval(:,3) Shuttle_CD(:,7) Hermes_CDssval(:,5)];
s=0;
for n=1:size(u5_CD,1)    % ciclo per il valore medio
    for m=1:size(u5_CD,2)
        t=any(u5_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u5_CDm(n,1)=sum(u5_CD(n,:))/s;   % media
    s=0;
end

u5_CL=[Hope_CLsubval(:,3) Shuttle_CL(:,7) Hermes_CLssval(:,5)];
s=0;
for n=1:size(u5_CL,1)    % ciclo per il valore medio
    for m=1:size(u5_CL,2)
        t=any(u5_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u5_CLm(n,1)=sum(u5_CL(n,:))/s;   % media
    s=0;
end

u5_EFF=[Hope_EFFsubval(:,3) Shuttle_EFF(:,7) Hermes_EFFssval(:,5)];
s=0;
for n=1:size(u5_EFF,1)    % ciclo per il valore medio
    for m=1:size(u5_EFF,2)
        t=any(u5_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u5_EFFm(n,1)=sum(u5_EFF(n,:))/s;   % media
    s=0;
end

% M=1.6

u6_CD=[Horus_CDhyval(:,1) Saenger_CDhyval(:,1)];
s=0;
for n=1:size(u6_CD,1)    % ciclo per il valore medio
    for m=1:size(u6_CD,2)
        t=any(u6_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u6_CDm(n,1)=sum(u6_CD(n,:))/s;   % media
    s=0;
end

u6_CL=[Horus_CLhyval(:,1) Saenger_CLhyval(:,1)];
s=0;
for n=1:size(u6_CL,1)    % ciclo per il valore medio
    for m=1:size(u6_CL,2)
        t=any(u6_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u6_CLm(n,1)=sum(u6_CL(n,:))/s;   % media
    s=0;
end

u6_EFF=[Horus_EFFhyval(:,1) Saenger_EFFhyval(:,1)];
s=0;
for n=1:size(u6_EFF,1)    % ciclo per il valore medio
    for m=1:size(u6_EFF,2)
        t=any(u6_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    u6_EFFm(n,1)=sum(u6_EFF(n,:))/s;   % media
    s=0;
end

% M=2

d_CD=[Hope_CDsuperval(:,4) Horus_CDhyval(:,2) Saenger_CDhyval(:,2) Shuttle_CD(:,8) X34_CDval(:,5) Hermes_CDssval(:,6)];
s=0;
for n=1:size(d_CD,1)    % ciclo per il valore medio
    for m=1:size(d_CD,2)
        t=any(d_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d_CDm(n,1)=sum(d_CD(n,:))/s;   % media
    s=0;
end

d_CL=[Hope_CLsuperval(:,4) Horus_CLhyval(:,2) Saenger_CLhyval(:,2)  Shuttle_CL(:,8) X34_CDval(:,5) Hermes_CLssval(:,6)];
s=0;
for n=1:size(d_CL,1)    % ciclo per il valore medio
    for m=1:size(d_CL,2)
        t=any(d_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d_CLm(n,1)=sum(d_CL(n,:))/s;   % media
    s=0;
end

d_EFF=[Hope_EFFsuperval(:,4) Horus_EFFhyval(:,2) Saenger_EFFhyval(:,2)  Shuttle_EFF(:,8) X34_CDval(:,5) Hermes_EFFssval(:,6)];
s=0;
for n=1:size(d_EFF,1)    % ciclo per il valore medio
    for m=1:size(d_EFF,2)
        t=any(d_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d_EFFm(n,1)=sum(d_EFF(n,:))/s;   % media
    s=0;
end

% M=2.5

d5_CD=Hermes_CDssval(:,7);
for n=1:size(d5_CD,1)    % ciclo per il valore medio
    for m=1:size(d5_CD,2)
        t=any(d5_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d5_CDm(n,1)=sum(d5_CD(n,:))/s;   % media
    s=0;
end

d5_CL=Hermes_CLssval(:,7);
for n=1:size(d5_CL,1)    % ciclo per il valore medio
    for m=1:size(d5_CL,2)
        t=any(d5_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d5_CLm(n,1)=sum(d5_CL(n,:))/s;   % media
    s=0;
end

d5_EFF=Hermes_EFFssval(:,7);
for n=1:size(d5_EFF,1)    % ciclo per il valore medio
    for m=1:size(d5_EFF,2)
        t=any(d5_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    d5_EFFm(n,1)=sum(d5_EFF(n,:))/s;   % media
    s=0;
end

% M=3

t_CD=[Hope_CDsuperval(:,5) Horus_CDhyval(:,3) Saenger_CDhyval(:,3) Shuttle_CD(:,9) Hermes_CDhyval(:,1)];
s=0;
for n=1:size(t_CD,1)    % ciclo per il valore medio
    for m=1:size(t_CD,2)
        t=any(t_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t_CDm(n,1)=sum(t_CD(n,:))/s;   % media
    s=0;
end

t_CL=[Hope_CLsuperval(:,5) Horus_CLhyval(:,3) Saenger_CLhyval(:,3)  Shuttle_CL(:,9) Hermes_CLhyval(:,1)];
s=0;
for n=1:size(t_CL,1)    % ciclo per il valore medio
    for m=1:size(t_CL,2)
        t=any(t_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t_CLm(n,1)=sum(t_CL(n,:))/s;   % media
    s=0;
end

t_EFF=[Hope_EFFsuperval(:,5) Horus_EFFhyval(:,3) Saenger_EFFhyval(:,3)  Shuttle_EFF(:,9) Hermes_EFFhyval(:,1)];
s=0;
for n=1:size(t_EFF,1)    % ciclo per il valore medio
    for m=1:size(t_EFF,2)
        t=any(t_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t_EFFm(n,1)=sum(t_EFF(n,:))/s;   % media
    s=0;
end

% M=3.5

t5_CD=Hope_CDsuperval(:,6);
for n=1:size(t5_CD,1)    % ciclo per il valore medio
    for m=1:size(t5_CD,2)
        t=any(t5_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t5_CDm(n,1)=sum(t5_CD(n,:))/s;   % media
    s=0;
end

t5_CL=Hope_CLsuperval(:,6);
for n=1:size(t5_CL,1)    % ciclo per il valore medio
    for m=1:size(t5_CL,2)
        t=any(t5_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t5_CLm(n,1)=sum(t5_CL(n,:))/s;   % media
    s=0;
end

t5_EFF=Hope_EFFsuperval(:,6);
for n=1:size(t5_EFF,1)    % ciclo per il valore medio
    for m=1:size(t5_EFF,2)
        t=any(t5_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    t5_EFFm(n,1)=sum(t5_EFF(n,:))/s;   % media
    s=0;
end

% M=4

q_CD=[Horus_CDhyval(:,4) Saenger_CDhyval(:,4) Shuttle_CD(:,10) X33_CDval(:,1) Hermes_CDhyval(:,2)];
s=0;
for n=1:size(q_CD,1)    % ciclo per il valore medio
    for m=1:size(q_CD,2)
        t=any(q_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    q_CDm(n,1)=sum(q_CD(n,:))/s;   % media
    s=0;
end

q_CL=[Horus_CLhyval(:,4) Saenger_CLhyval(:,4)  Shuttle_CL(:,10) X33_CLval(:,1) Hermes_CLhyval(:,2)];
s=0;
for n=1:size(q_CL,1)    % ciclo per il valore medio
    for m=1:size(q_CL,2)
        t=any(q_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    q_CLm(n,1)=sum(q_CL(n,:))/s;   % media
    s=0;
end

q_EFF=[Horus_EFFhyval(:,4) Saenger_EFFhyval(:,4)  Shuttle_EFF(:,10) X33_EFFval(:,1) Hermes_EFFhyval(:,2)];
s=0;
for n=1:size(q_EFF,1)    % ciclo per il valore medio
    for m=1:size(q_EFF,2)
        t=any(q_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    q_EFFm(n,1)=sum(q_EFF(n,:))/s;   % media
    s=0;
end

% M=5

c_CD=[Shuttle_CDiper(:,1) X33_CDval(:,2)];
s=0;
for n=1:size(c_CD,1)    % ciclo per il valore medio
    for m=1:size(c_CD,2)
        t=any(c_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    c_CDm(n,1)=sum(c_CD(n,:))/s;   % media
    s=0;
end

c_CL=[Shuttle_CLiper(:,1) X33_CLval(:,2)];
s=0;
for n=1:size(c_CL,1)    % ciclo per il valore medio
    for m=1:size(c_CL,2)
        t=any(c_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    c_CLm(n,1)=sum(c_CL(n,:))/s;   % media
    s=0;
end

c_EFF=[Shuttle_EFFiper(:,1) X33_EFFval(:,2) ];
s=0;
for n=1:size(c_EFF,1)    % ciclo per il valore medio
    for m=1:size(c_EFF,2)
        t=any(c_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    c_EFFm(n,1)=sum(c_EFF(n,:))/s;   % media
    s=0;
end

% M=6

s_CD=[Horus_CDhyval(:,5) Saenger_CDhyval(:,5) Shuttle_CDiper(:,2) X33_CDval(:,3) X34_CDval(:,6) Hermes_CDhyval(:,3)];
s=0;
for n=1:size(s_CD,1)    % ciclo per il valore medio
    for m=1:size(s_CD,2)
        t=any(s_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    s_CDm(n,1)=sum(s_CD(n,:))/s;   % media
    s=0;
end

s_CL=[Horus_CLhyval(:,5) Saenger_CLhyval(:,5)  Shuttle_CLiper(:,2) X33_CLval(:,3) X34_CLval(:,6) Hermes_CLhyval(:,3)];
s=0;
for n=1:size(s_CL,1)    % ciclo per il valore medio
    for m=1:size(s_CL,2)
        t=any(s_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    s_CLm(n,1)=sum(s_CL(n,:))/s;   % media
    s=0;
end

s_EFF=[Horus_EFFhyval(:,5) Saenger_EFFhyval(:,5) Shuttle_EFFiper(:,2) X33_EFFval(:,3) X34_EFFval(:,6) Hermes_EFFhyval(:,3)];
s=0;
for n=1:size(s_EFF,1)    % ciclo per il valore medio
    for m=1:size(s_EFF,2)
        t=any(s_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    s_EFFm(n,1)=sum(s_EFF(n,:))/s;   % media
    s=0;
end

% M=7

se_CD=[Horus_CDhyval(:,6) Saenger_CDhyval(:,6)];
s=0;
for n=1:size(se_CD,1)    % ciclo per il valore medio
    for m=1:size(se_CD,2)
        t=any(se_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    se_CDm(n,1)=sum(se_CD(n,:))/s;   % media
    s=0;
end

se_CL=[Horus_CLhyval(:,6) Saenger_CLhyval(:,6)];
s=0;
for n=1:size(se_CL,1)    % ciclo per il valore medio
    for m=1:size(se_CL,2)
        t=any(se_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    se_CLm(n,1)=sum(se_CL(n,:))/s;   % media
    s=0;
end

se_EFF=[Horus_EFFhyval(:,6) Saenger_EFFhyval(:,6)];
s=0;
for n=1:size(se_EFF,1)    % ciclo per il valore medio
    for m=1:size(se_EFF,2)
        t=any(se_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    se_EFFm(n,1)=sum(se_EFF(n,:))/s;   % media
    s=0;
end

% M=8

o_CD=[Shuttle_CDiper(:,3) X33_CDval(:,4) Hermes_CDhyval(:,4)];
s=0;
for n=1:size(o_CD,1)    % ciclo per il valore medio
    for m=1:size(o_CD,2)
        t=any(o_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    o_CDm(n,1)=sum(o_CD(n,:))/s;   % media
    s=0;
end

o_CL=[Shuttle_CLiper(:,3) X33_CLval(:,4) Hermes_CLhyval(:,4)];
s=0;
for n=1:size(o_CL,1)    % ciclo per il valore medio
    for m=1:size(o_CL,2)
        t=any(o_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    o_CLm(n,1)=sum(o_CL(n,:))/s;   % media
    s=0;
end

o_EFF=[Shuttle_EFFiper(:,3) X33_EFFval(:,4) Hermes_EFFhyval(:,4)];
s=0;
for n=1:size(o_EFF,1)    % ciclo per il valore medio
    for m=1:size(o_EFF,2)
        t=any(o_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    o_EFFm(n,1)=sum(o_EFF(n,:))/s;   % media
    s=0;
end

% M=10

di_CD=[X33_CDval(:,5) Hermes_CDhyval(:,5)];
s=0;
for n=1:size(di_CD,1)    % ciclo per il valore medio
    for m=1:size(di_CD,2)
        t=any(di_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    di_CDm(n,1)=sum(di_CD(n,:))/s;   % media
    s=0;
end

di_CL=[X33_CLval(:,5) Hermes_CLhyval(:,5)];
s=0;
for n=1:size(di_CL,1)    % ciclo per il valore medio
    for m=1:size(di_CL,2)
        t=any(di_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    di_CLm(n,1)=sum(di_CL(n,:))/s;   % media
    s=0;
end

di_EFF=[X33_EFFval(:,5) Hermes_EFFhyval(:,5)];
s=0;
for n=1:size(di_EFF,1)    % ciclo per il valore medio
    for m=1:size(di_EFF,2)
        t=any(di_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    di_EFFm(n,1)=sum(di_EFF(n,:))/s;   % media
    s=0;
end

% M=20

v_CD=Hermes_CDhyval(:,6);
for n=1:size(v_CD,1)    % ciclo per il valore medio
    for m=1:size(v_CD,2)
        t=any(v_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    v_CDm(n,1)=sum(v_CD(n,:))/s;   % media
    s=0;
end

v_CL=Hermes_CLhyval(:,6);
for n=1:size(v_CL,1)    % ciclo per il valore medio
    for m=1:size(v_CL,2)
        t=any(v_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    v_CLm(n,1)=sum(v_CL(n,:))/s;   % media
    s=0;
end

v_EFF=Hermes_EFFhyval(:,6);
for n=1:size(v_EFF,1)    % ciclo per il valore medio
    for m=1:size(v_EFF,2)
        t=any(v_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    v_EFFm(n,1)=sum(v_EFF(n,:))/s;   % media
    s=0;
end

% M=30

tr_CD=Hermes_CDhyval(:,7);
for n=1:size(tr_CD,1)    % ciclo per il valore medio
    for m=1:size(tr_CD,2)
        t=any(tr_CD(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    tr_CDm(n,1)=sum(tr_CD(n,:))/s;   % media
    s=0;
end

tr_CL=Hermes_CLhyval(:,7);
for n=1:size(tr_CL,1)    % ciclo per il valore medio
    for m=1:size(tr_CL,2)
        t=any(tr_CL(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    tr_CLm(n,1)=sum(tr_CL(n,:))/s;   % media
    s=0;
end

tr_EFF=Hermes_EFFhyval(:,7);
for n=1:size(tr_EFF,1)    % ciclo per il valore medio
    for m=1:size(tr_EFF,2)
        t=any(tr_EFF(n,m));  %se casella = 0 allora non viene calcolata nella media
        s=s+t;
        
    end
    tr_EFFm(n,1)=sum(tr_EFF(n,:))/s;   % media
    s=0;
end

% Supersonico
superlegenda={'M=1.05','M=1.1','M=1.2','M=1.3','M=1.5','M=1.6','M=2','M=2.5','M=3','M=3.5','M=4','M=5','M=6','M=7','M=8','M=10','M=20','M=30'};   % Mach di volo

%CL
CLsupermedio=[u05_CLm u1_CLm u2_CLm u3_CLm u5_CLm u6_CLm d_CLm d5_CLm t_CLm t5_CLm q_CLm c_CLm s_CLm ...
    se_CLm o_CLm di_CLm v_CLm tr_CLm];


for n=1:size(CLsupermedio,2)
    CLsuperspline(n) = spap2(4,3,alpha,CLsupermedio(:,n));                          % fitting per CD
    hold on
end

% CD
CDsupermedio=[u05_CDm u1_CDm u2_CDm u3_CDm u5_CDm u6_CDm d_CDm d5_CDm t_CDm t5_CDm q_CDm c_CDm s_CDm ...
    se_CDm o_CDm di_CDm v_CDm tr_CDm];

for n=1:size(CDsupermedio,2)
    CDsuperspline(n) = spap2(4,3,alpha,CDsupermedio(:,n));                          % fitting per CD
    hold on
end

% L/D
EFFsupermedio=[u05_EFFm u1_EFFm u2_EFFm u3_EFFm u5_EFFm u6_EFFm d_EFFm d5_EFFm t_EFFm t5_EFFm q_EFFm c_EFFm ...
    s_EFFm se_EFFm o_EFFm di_EFFm v_EFFm tr_EFFm];

for n=1:size(EFFsupermedio,2)
    EFFsuperspline(n) = spap2(4,3,alpha, EFFsupermedio(:,n));                          % fitting per L/D
    hold on
end

% Vettore unico
aaaCLspline=[CLsubspline CLsuperspline];
aaaCDspline=[CDsubspline CDsuperspline];
aaaEFFspline=[EFFsubspline EFFsuperspline];

f=1;
figure(f)
for i=1:length(CLsubspline)
    fnplt(CLsubspline(i))
    hold on
end
title('Subsonic Lift Coefficient','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('CL','FontSize',14)
legend(sublegenda,'Location','northeast','FontSize',12)

f=f+1;

figure(f)
for i=1:length(CLsuperspline)
    fnplt(CLsuperspline(i))
    hold on
    
end
title('Supersonic & Hypersonic Lift Coefficient','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('CL','FontSize',14)
legend(superlegenda,'Location','northeast','FontSize',12)

f=f+1;

figure(f)
for i=1:length(CDsubspline)
    fnplt(CDsubspline(i))
    hold on
    
end
title('Subsonic Drag Coefficient','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('CD','FontSize',14)
legend(sublegenda,'Location','northeast','FontSize',12)

f=f+1;

figure(f)
for i=1:length(CDsuperspline)
    fnplt(CDsuperspline(i))
    hold on
end
title('Supersonic & Hypersonic Drag Coefficient','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('CD','FontSize',14)
legend(superlegenda,'Location','northeast','FontSize',12)

f=f+1;

figure(f)
for i=1:length(EFFsubspline)
    fnplt(EFFsubspline(i))
    hold on
end
title('Subsonic Efficiency','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('L/D','FontSize',14)
legend(sublegenda,'Location','northeast','FontSize',12)

f=f+1;

figure(f)
for i=1:length(EFFsuperspline)
    fnplt(EFFsuperspline(i))
    hold on
end
title('Supersonic & Hypersonic Efficiency','FontSize',15)
xlabel('Angle of attak \alpha','FontSize',14)
ylabel('L/D','FontSize',14)
legend(superlegenda,'Location','northeast','FontSize',12)

f=f+1;

%% Costanti
G=6.67384 * 10^-11;  % costante gravitazionale [m^3 kg^-1 s^-2]
R=287; %J/(kg/K)
G_earth=6.67*10^-11; % costante gravitazionale N*m^2/kg^2
M_earth=5.972*10^24; % massa Terra kg
R_earth=6371000; % raggio terra m
g0=9.81;   % accelerazione gravità [m s^-2]
rho0=1.225;   % densità aria a livello del mare [kg m^-3]

asos=341.4*0.86; % velocità del suono media (35000m)[m/s]

%% Input  Za
CL_la=1;         % CL take off

%% Pesi
% Input
gm_2s=80.5;  %[°] angolo attacco ali (freccia)

b_2s=2;  % [m] semiasse minore
a_2s=6;   % [m] semiasse maggiore
Wppl_2s=4000;  %[kg] peso propellente
W_pay_2s=5000;  % [kg] peso payload
fattore1_2s=0.04;
fattore2_2s=0.65;

% Calcolo
%calcolo massa II stadio
i=2;
W_dry_2s=10000;
Wdrysec2=0;
pesi=zeros(100,1);
pesi(1,1)=0;
pesi(2,1)=W_dry_2s;

while abs(pesi(i)-pesi(i-1))>1 && i<100
    I_str_2s=35;
    gm_rad_2s=pi*gm_2s/180; %rad
    res_2s=cos(gm_rad_2s);
    
    e_2s=b_2s/a_2s;
    R_2s=(1-e_2s)/(1+e_2s);
    S_wet_2s=pi*a_2s^2*((1+e_2s)/(cos(gm_rad_2s)))*(1+((R_2s^2)/4)+((R_2s^4)/64)+((R_2s^6)/256))+pi*a_2s^2*e_2s;
    S_pln_2s=a_2s^2*tan(gm_rad_2s);
    vol_2s=((pi*a_2s^3*e_2s)/3)*tan(gm_rad_2s);
    
    Kw_2s=S_wet_2s/S_pln_2s;
    C_un_2s=2000;
    f_mnd_2s=1300;
    N_crew_2s=2;
    C_sys_2s=C_un_2s+f_mnd_2s*N_crew_2s;
    f_cpv_2s=500;
    W_cpv_2s=f_cpv_2s*N_crew_2s;
    %fattore1_2s=0.01; %TW0*Wr/Etw
    W_crew_2s=160;
    
    W_str_2s=I_str_2s*Kw_2s*S_pln_2s;
    W_sys_2s=C_sys_2s+W_cpv_2s;
    W_eng_2s=fattore1_2s*(W_dry_2s+W_pay_2s+W_crew_2s);
    
    Wdrysec2=(I_str_2s*Kw_2s*S_pln_2s+C_sys_2s+W_cpv_2s+fattore1_2s*(W_dry_2s+W_pay_2s+W_crew_2s))/(fattore2_2s-fattore1_2s); %W-Wppl-Wpaylaod
    Wr_2s=(W_dry_2s+Wppl_2s+W_pay_2s)/(W_dry_2s); %(Wdry+Wpayload+Wppl)/(Wdry)
    Wss=W_dry_2s+Wppl_2s+W_pay_2s;
    
    W_dry_2s=Wdrysec2;
    i=i+1;
    pesi(i)=Wdrysec2;
end

b_1s=8.5;
a_1s=20;
gm_1s=65;
fattore1_1s=0.10;

%Calcolo massa I stadio
i=2;
W_dry_1s=10000;
Wdrysec1=0;
pesi=zeros(100,1);
pesi(1,1)=0;
pesi(2,1)=W_dry_1s;

while abs(pesi(i)-pesi(i-1))>1 && i<100
    I_str_1s=30;
    e_1s=b_1s/a_1s;
    gm_rad_1s=pi*gm_1s/180; %rad
    res_1s=cos(gm_rad_1s);
    R_1s=(1-e_1s)/(1+e_1s);
    S_wet_1s=pi*a_1s^2*((1+e_1s)/(cos(gm_rad_1s)))*(1+((R_1s^2)/4)+((R_1s^4)/64)+((R_1s^6)/256))+pi*a_1s^2*e_1s;
    S_pln_1s=a_1s^2*tan(gm_rad_1s);
    Kw_1s=S_wet_1s/S_pln_1s;
    C_un_1s=2000;
    f_mnd_1s=1300;
    N_crew_1s=2;
    C_sys_1s=C_un_1s+f_mnd_1s*N_crew_1s;
    f_cpv_1s=500;
    W_cpv_1s=f_cpv_1s*N_crew_1s;
    %fattore1_1s=0.1; %TW0*Wr/Etw
    W_pay_1s=Wss;
    W_crew_1s=160;
    fattore2_1s=0.65;
    Wppl_1s=60000;
    
    Wdrysec1=(I_str_1s*Kw_1s*S_pln_1s+C_sys_1s+W_cpv_1s+fattore1_1s*(W_dry_1s+W_pay_1s+W_crew_1s))/(fattore2_1s-fattore1_1s); %W-Wppl-Wpaylaod
    Wr_1s=(W_dry_1s+Wppl_1s+W_pay_1s)/(W_dry_1s); %(Wdry+Wpayload+Wppl)/(Wdry)
    W=W_dry_1s+Wppl_1s+W_pay_1s;
    
    W_dry_1s=Wdrysec1;
    i=i+1;
    pesi(i)=Wdrysec1;
end

%% Input Civita
z=250*1000;   % orbita [m]
z_de=120*1000; % h deorbit [m]
R_orbit=R_earth+z;  % distanza centro terrestre orbita [m]
R_deorbit=R_earth+z_de;   %  % distanza centro terrestre deorbita [m]
vsat=sqrt(G_earth*M_earth/R_orbit);  % velocità orbitale [m s^-1]
v_de=sqrt(G_earth*M_earth/R_deorbit);  %velocità deobrit [m s^-1]
v=1000:v_de;   % vettore ascissa velocità [m/s]
M=v./asos;    % vettore Mach
aM=min(M);  % preso il valore minimo perchè è il più ristrettivo

G1=65.1;  % coefficienti calore (Boundery 2)
G2=-0.015;
G3=8.97*10^-7;

bank=50; % banking angle

gammae=10.5;   %(Descending angle)
Hs=8500;  % (m)

qmax=24.3*1000;  % (N/m2) (Pa)

% tol_C=1.6; % tolleranza corridoio  [m s^-2]

CL=coeff(aaaCLspline,aM,gammae);
CD=coeff(aaaCDspline,aM,gammae);
LD=coeff(aaaEFFspline,aM,gammae);

b=Wss/(CD*S_pln_2s);  % coefficiente balistico (kg/m2)

Dref2=G1+G2*v+G3*v.^2;  % Heat rate Boundery 2
Dref1=g0*(1-v.^2/vsat^2)./(LD.*cos(bank*pi/180));  % Equilibrium glide Boundery 1

gmax=(v_de)^2.*sin(gammae*pi/180)/(2*exp(1)*g0*Hs);
gl_max=g0*exp(2*gammae*pi/180/LD)/LD;    %Gl/Gmax
%     gl_max=(vsat)*exp(2*gammae*pi/180./LD);   %Gl/Gmax
gwing=gl_max.*gmax;                    % Gwing=Gl/Gmax*Gmax

Dref3=gwing./sqrt(1+LD.^2);  % Total sensed acceleration Boundary 3
G4=Dref3;
Dref3=ones(1,length(v))*G4;

qmax=24.3*1000;  % (N/m2) (Pa)
Dref4=qmax./b; %Dynamic Pressure Boundery 4
Dref4=ones(1,length(v))*Dref4;

%     Di=Dref4(1);   % Drag iniziale
%
%     xl=ones(1,2); %processo per tovare intersezione D2 & D4
%     tol=10;
%     while length(xl)>1
%     [xl,yl]=find(abs(Dref2-Dref4)<tol);
%     tol=tol-0.001;
%     end
%     vi=v(yl)-1000;
%     hi=-Hs*log(2*Di*b/(rho0*vi^2));
%     Df=1;
%     vf=1000;
%     hf=-Hs*log(2*Df*b/(rho0*vf^2));
%
%     Ei=g0*hi+vi^2/2;
%     Ef=g0*hf+vf^2/2;
%     G5=(Di-Df)/(Ei-Ef);
%
%     vlin=vf:vi;
%     h=linspace(hf,hi,length(vlin));
%     E=g0.*h+vlin.^2/2;
%
%     Dref5=Df+G5.*(E-Ef);

%%  Ciclo ottimizzazione
% invariabili
max3=9.81*8; % massimo B3
min4=6;
max4=25;
max1=min4+6;
maxcont=1000000;
maxgammae=30;
mingammae=5;
gm_2smax=85;  % [°] angolo attacco ali (freccia)
gm_2smin=20;
b_2smax=30;  % [m] max semiasse minore
a_2smax=100;   % [m] max semiasse maggiore
zmax=300*1000; % [m] orbita massima
zmin=150*1000; % [m] orbita min
z_demax=150*1000;    %[m] max deorbit
z_demin=130*1000; % [m] min deorbit
cont=1;
tolcorr=0.5;  % tolleranza corridoio
tol4=3; % tolleranza B1 & B4
minbank=28;  %Shuttle & X-38

while(Dref4(1)<min4 || Dref4(1)>max4 || Dref3(1)>max3 && cont<maxcont)  %Ottimizzazione Dref3&4
    
    if(Dref4(1)<min4)
        if(gammae<maxgammae)
            gammae=gammae+0.001;
        elseif(gm_2s<gm_2smax)
            gm_2s=gm_2s+0.01;
        elseif(b_2s<b_2smax)
            a_2s=a_2s+1;
            b_2s=b_2s+b_2s/a_2s;
        end
    end
    
    if(Dref4(1)>max4 || Dref3(3)>max3)
        if(gammae>mingammae)
            gammae=gammae-0.001;
        elseif z_de>z_demin
            z_de=z_de+1;
        elseif(gm_2s>gm_2smin)
            gm_2s=gm_2s-0.01;
        else
            disp('Non convergono B4 & B3')
        end
    end
    
    %Masse e Superfici
    
    Wppl_2s=4000;  %[kg] peso propellente
    W_pay_2s=5000;  % [kg] peso payload
    fattore1_2s=0.04;
    fattore2_2s=0.65;
    
    % Calcolo
    %calcolo massa II stadio
    i=2;
    W_dry_2s=10000;
    Wdrysec2=0;
    pesi=zeros(100,1);
    pesi(1,1)=0;
    pesi(2,1)=W_dry_2s;
    
    while abs(pesi(i)-pesi(i-1))>1 && i<100
        I_str_2s=35;
        gm_rad_2s=pi*gm_2s/180; %rad
        res_2s=cos(gm_rad_2s);
        
        e_2s=b_2s/a_2s;
        R_2s=(1-e_2s)/(1+e_2s);
        S_wet_2s=pi*a_2s^2*((1+e_2s)/(cos(gm_rad_2s)))*(1+((R_2s^2)/4)+((R_2s^4)/64)+((R_2s^6)/256))+pi*a_2s^2*e_2s;
        S_pln_2s=a_2s^2*tan(gm_rad_2s);
        vol_2s=((pi*a_2s^3*e_2s)/3)*tan(gm_rad_2s);
        
        Kw_2s=S_wet_2s/S_pln_2s;
        C_un_2s=2000;
        f_mnd_2s=1300;
        N_crew_2s=2;
        C_sys_2s=C_un_2s+f_mnd_2s*N_crew_2s;
        f_cpv_2s=500;
        W_cpv_2s=f_cpv_2s*N_crew_2s;
        %fattore1_2s=0.01; %TW0*Wr/Etw
        W_crew_2s=160;
        
        W_str_2s=I_str_2s*Kw_2s*S_pln_2s;
        W_sys_2s=C_sys_2s+W_cpv_2s;
        W_eng_2s=fattore1_2s*(W_dry_2s+W_pay_2s+W_crew_2s);
        
        Wdrysec2=(I_str_2s*Kw_2s*S_pln_2s+C_sys_2s+W_cpv_2s+fattore1_2s*(W_dry_2s+W_pay_2s+W_crew_2s))/(fattore2_2s-fattore1_2s); %W-Wppl-Wpaylaod
        Wr_2s=(W_dry_2s+Wppl_2s+W_pay_2s)/(W_dry_2s); %(Wdry+Wpayload+Wppl)/(Wdry)
        Wss=W_dry_2s+Wppl_2s+W_pay_2s;
        
        W_dry_2s=Wdrysec2;
        i=i+1;
        pesi(i)=Wdrysec2;
    end
    
    b_1s=8.5;
    a_1s=20;
    fattore1_1s=0.10;
    
    %Calcolo massa I stadio
    i=2;
    W_dry_1s=10000;
    Wdrysec1=0;
    pesi=zeros(100,1);
    pesi(1,1)=0;
    pesi(2,1)=W_dry_1s;
    
    while abs(pesi(i)-pesi(i-1))>1 && i<100
        I_str_1s=30;
        e_1s=b_1s/a_1s;
        gm_rad_1s=pi*gm_1s/180; %rad
        res_1s=cos(gm_rad_1s);
        R_1s=(1-e_1s)/(1+e_1s);
        S_wet_1s=pi*a_1s^2*((1+e_1s)/(cos(gm_rad_1s)))*(1+((R_1s^2)/4)+((R_1s^4)/64)+((R_1s^6)/256))+pi*a_1s^2*e_1s;
        S_pln_1s=a_1s^2*tan(gm_rad_1s);
        Kw_1s=S_wet_1s/S_pln_1s;
        C_un_1s=2000;
        f_mnd_1s=1300;
        N_crew_1s=2;
        C_sys_1s=C_un_1s+f_mnd_1s*N_crew_1s;
        f_cpv_1s=500;
        W_cpv_1s=f_cpv_1s*N_crew_1s;
        %fattore1_1s=0.1; %TW0*Wr/Etw
        W_pay_1s=Wss;
        W_crew_1s=160;
        fattore2_1s=0.65;
        Wppl_1s=60000;
        
        Wdrysec1=(I_str_1s*Kw_1s*S_pln_1s+C_sys_1s+W_cpv_1s+fattore1_1s*(W_dry_1s+W_pay_1s+W_crew_1s))/(fattore2_1s-fattore1_1s); %W-Wppl-Wpaylaod
        Wr_1s=(W_dry_1s+Wppl_1s+W_pay_1s)/(W_dry_1s); %(Wdry+Wpayload+Wppl)/(Wdry)
        W=W_dry_1s+Wppl_1s+W_pay_1s;
        
        W_dry_1s=Wdrysec1;
        i=i+1;
        pesi(i)=Wdrysec1;
    end
    
    R_deorbit=R_earth+z_de;   %  % distanza centro terrestre deorbita [m]
    v_de=sqrt(G_earth*M_earth/R_deorbit);  %velocità deobrit [m s^-2]
    v=1000:v_de;   % vettore ascissa velocità [m/s]
    M=v./asos;    % vettore Mach
    aM=min(M);  % preso il valore minimo perchè è il più restrettivo
    
    CD=coeff(aaaCDspline,aM,gammae);
    
    b=W_dry_2s/(CD*S_wet_2s);  % coefficiente balistico (kg/m2)
    Dref4=qmax./b; %Dynamic Pressure Boundery 4
    Dref4=ones(1,length(v))*Dref4;
    
    LD=coeff(aaaEFFspline,aM,gammae);
    
    gmax=(vsat)^2.*sin(gammae*pi/180)/(2*exp(1)*g0*Hs);
    gl_max=g0*exp(2*gammae*pi/180/LD)/LD;    %Gl/Gmax
    gwing=gl_max.*gmax;                    % Gwing=Gl/Gmax*Gmax
    
    Dref3=gwing./sqrt(1+LD.^2);  % Total sensed acceleration Boundary 3
    G4=Dref3;
    Dref3=ones(1,length(v))*G4;
    
    cont=cont+1;
    if (cont>=maxcont)
        disp(' raggiunto max cont B4')
    end
end

s=1;
cont=1;
n=1;

%Ridefinizione di Boundery 1&2 tenendo conto della variazione di LD dovuta al ciclo precedente
Dref2=G1+G2*v+G3*v.^2;  % Heat rate Boundery 2
Dref1=g0*(1-v.^2/vsat^2)./(LD.*cos(bank*pi/180));  % Equilibrium glide Boundery 1

while s==1 || Dref4(1)-max(Dref1)<tol4 && cont<maxcont
    
    s=0;
    while s==0 && n<length(Dref1)   %ciclo per verificare la corretta larghezza del corridoio
        s=Dref2(n)-Dref1(n)<tolcorr;  %se s=0 per ogni Dref2-Dref1 allora il corridoio è presente
        n=n+1;                          % se s=1 si esce dal ciclo e si vanno a modificare i parametri
    end
    
    if s==1
        if bank>minbank
            bank=bank-0.01;
        elseif z>zmin
            z=z-1;
        else
            disp('Non coverge B1')
        end
    end
    
    if Dref4(1)-max(Dref1)<tol4
        bank=bank-0.01;
    end
    
    Dref2=G1+G2*v+G3*v.^2;  % Heat rate Boundery 2
    Dref1=g0*(1-v.^2/vsat^2)./(LD.*cos(bank*pi/180));  % Equilibrium glide Boundery 1
    
    cont=cont+1;
    if (cont>=maxcont)
        disp(' raggiunto max cont B1')
        
    end
end

%Costruzione Boundery Linere

Di=Dref4(1);   % Drag iniziale

xl=ones(1,2); %processo per tovare intersezione D2 & D4
tol=10;
while length(xl)>1
    [xl,yl]=find(abs(Dref2-Dref4)<tol);
    tol=tol-0.001;
end
vi=v(yl)-1000;
hi=-Hs*log(2*Di*b/(rho0*vi^2));
Df=max(Dref1-2);
vf=1000;
hf=-Hs*log(2*Df*b/(rho0*vf^2));

Ei=g0*hi+vi^2/2;
Ef=g0*hf+vf^2/2;
G5=(Di-Df)/(Ei-Ef);

vlin=vf:vi;
h=linspace(hf,hi,length(vlin));
E=g0.*h+vlin.^2/2;

Dref5=Df+G5.*(E-Ef);

figure(f)
plot(v,Dref1)
hold on
plot(v(2200:end),Dref2(2200:end))
hold on
plot(v,Dref3)
hold on
plot(v,Dref4)
hold on
plot(vlin,Dref5)
title('Entry Corridor','FontSize',15)
xlabel('Velocity (m/s)','FontSize',14)
ylabel('Drag acceleration (m/s^2)','FontSize',14)
sslegenda={'Boundary 1','Boundary 2','Boundary 3','Boundary 4','Boundary 5'};
legend(sslegenda,'Location','northeast','FontSize',12)

f=f+1;

%% Matching chart
%costanti
T0=288;   %[K]
ro0=1.225;   %[m/kg3]
ht=0.0065; %[K/m] gradiente di temperatura nella troposfera
h_airportTO=50; %[m]
TO_dist=2500;     %[m]
TO_dist_ft=TO_dist/0.3;   %[ft]
h_airportLND=50; %[m]
Mach_cruise=4;
gamma_aria=1.4; %rapporto tra calore specifico a pressione e volume costante
p0=101325; %[Pa] pressione ambiente
lambda1=1;  %allungaento alare
Cd0=0.016;   %da valutare
Ts0=1600000; %valore di prima iterazione della spinta statica airbreathing
k=0.0013; %K/m gradiente di temperatura nella stratosfera
Mach_climb=2;
Ug=8200;%m/s velocità di efflusso dei gas in usicta airbreathing
e=0.8;   %Il fattore di Oswald è tipicamente compreso fra 0.7 e 0.85  (http://www.ingaero.uniroma1.it/attachments/635_parte_1.pdf)
gamma_climb=1;   % [°]angolo di salita
LND_dist_2s=4000;  %[m] landing distance
LND_dist=4000;     %[m] landing distance
Cl_max_LND_1s=0.5;    %maximum landing CL 1s
h_airportLND2s=200;  %[m] altitudine aeroporto arrivo
Mppl=40000;  %[kg] massa propellente
T_rocket=2200000; %valore di prima iterazione della spinta del rocket
Ue=6000; %velocità efficace di scarico
ro_f=70.8; %kg/m^3 denistà fuel idrogeno liquido
ro_ox=1141; %kg/m^3 densità oxidider ossigeno liquido
MR=6; %mixture ratio
ro_ppl=(1+MR)/((1/ro_f)+(MR/ro_ox));  %densità propellente
gamma_orbit=20;  %[°] angolo raggiungimento orbita
teta_grad=1.5;
Cd_rientro=0.3;

%requisito di decollo
T_airportTO=T0-ht*h_airportTO;
ro_airportTO=ro0*((T0-ht*h_airportTO)/T0)^4.2561;
sigma_TO=ro_airportTO/ro0;
TOP=TO_dist_ft/20;
WS=0:800;
Cl_max_to=coeff(aaaCLspline,0.3,11);
TW_tols=WS/(sigma_TO*Cl_max_to*TO_dist);

%requisito di atterraggio I stadio
T_airportLND=T0-ht*h_airportLND;
ro_airportLND=ro0*((T0-ht*h_airportLND)/T0)^4.2561;
sigma_LND=ro_airportLND/ro0;
Vst_LND=sqrt(LND_dist/0.507);
WlS=0.5*ro_airportLND*((Vst_LND)^2)*Cl_max_LND_1s;
Wl=W-Wss;
Wl_W=Wl/W;
TW_lnd1s=linspace(0,60,6);
WS_lnd1s=WlS*(1/Wl_W)/9.81*ones(size(TW_lnd1s))*sigma_LND;

%requisito di salita
W_climb=W;
Emax=sqrt((e*pi*lambda1)/(4*Cd0));
confr=W_climb/(Ts0*Emax);

incr=0.05;
z_supporto=0;
flag=0;
while (z_supporto<300000) && (flag==0)
    if z_supporto<10000
        Tq=T0-ht*z_supporto;
        pq=p0*((T0-ht*z_supporto)/T0)^5.2561;
    else if z_supporto>10001 && z_supporto<20000
            Tq=213;
            pq=(p0*((T0-ht*10000)/T0)^5.2561)*exp(-(z_supporto-10000)/6338);
        else if z_supporto>20001 && z_supporto<300000
                Tq=T0+k*z_supporto;
                pq=10000;
            end
        end
    end
    
    psi=(pq/p0)*(T0/Tq)^1.75;
    Vsuono=sqrt(gamma_aria*R*Tq);
    V=Mach_climb*Vsuono;
    csi=(1-V/Ug);
    prod=csi*psi;
    
    if (prod)<(confr+incr) && (prod)>(confr-incr)
        z_tang=z_supporto;
        flag=1;
    else
        z_supporto=z_supporto+20;
        z_tang=50000;
    end
end

z_climb=0.5*z_tang;
T_climb=T0-ht*z_climb;
ro_climb=ro0*(T_climb/T0)^4.2561;
V_climb=Mach_climb*sqrt(gamma_aria*R*T_climb);
Wratio=0.95;

pq=p0*((T0-ht*z_climb)/T0)^5.2561;
psi=(pq/p0)*(T0/Tq)^1.75;
csi=(1-V_climb/Ug);
Th=psi*csi*Ts0;
Tratio=Th/Ts0;

pres_din=0.5*ro_climb*(V_climb)^2;
I_term_climb=(Cd0*0.5*ro_climb*(V_climb)^2)/Wratio;
II_term_climb=Wratio/(0.5*ro_climb*(V_climb)^2*pi*lambda1*e);
III_term_climb=Wratio/Tratio;

TW_climb1s=(I_term_climb./(WS*9.81)+II_term_climb.*(WS*9.81))*III_term_climb+sin(pi/180*gamma_climb);

%requisito di crociera
W_cruise=W;
z_cruise=0.9*z_tang;

if z_supporto>10001 && z_supporto<20000
    T_cruise=213;
else if z_supporto>20001 && z_supporto<300000
        T_cruise=T0+k*z_supporto;
    end
end
ro_cruise=ro0*(T_cruise/T0)^4.2561;
V_cruise=Mach_cruise*sqrt(gamma_aria*R*T_cruise);
Wratio=0.7;

pq=p0*((T0+k*z_supporto)/T0)^5.2561;
psi=(pq/p0)*(T0/Tq)^1.75;
csi=(1-V_cruise/Ug);
Th=psi*csi*Ts0;
Tratio=Th/Ts0;

pres_din_cruise=0.5*ro_cruise*(V_cruise)^2;
I_term_cruise=(Cd0*0.5*ro_cruise*(V_cruise)^2)/Wratio;
II_term_cruise=Wratio/(0.5*ro_cruise*(V_cruise)^2*pi*lambda1*e);
III_term_cruise=Wratio/Tratio;

TW_cruise1s=(I_term_cruise./(WS*9.81)+II_term_cruise.*(WS*9.81))*III_term_cruise;

%requisito di atterraggio II stadio
Vst_LND=sqrt(LND_dist_2s/0.507);
T_airportLND2s=T0-ht*h_airportLND2s;
ro_airportLND2s=ro0*((T0-ht*h_airportLND2s)/T0)^4.2561;
sigma_LND2=ro_airportLND2s/ro0;
Cl_max_LND=coeff(aaaCLspline,0.3,9);
WlS=0.5*ro_airportLND2s*((Vst_LND)^2)*Cl_max_LND;
Wl=Wss-Mppl;
Wl_W=(Wss-Mppl)/Wss;

TW_lnd2s=linspace(0,60,6);
WS_lnd2s=WlS*(1/Wl_W)/9.81*ones(size(TW_lnd2s))*sigma_LND2;

%requisito di D4
TW=linspace(0,30,6);
WS_D4=qmax*CD/Dref4(1)*ones(size(TW));

%Desing point
XD1=WS_lnd1s(1);

YD1=max((I_term_cruise./(XD1*9.81)+II_term_cruise.*(XD1*9.81))*III_term_cruise,...
    (I_term_climb./(XD1*9.81)+II_term_climb.*(XD1*9.81))*III_term_climb+sin(pi/180*gamma_climb));

figure(f)
plot(WS,TW_tols)
hold on
plot(WS,TW_climb1s)
hold on
plot(WS,TW_cruise1s)
hold on
plot(WS_lnd1s,TW_lnd1s)
hold on
plot(XD1,YD1,'*','MarkerSize',10,'MarkerEdgeColor','r')

xlim([0 800])
ylim([0 5])

title('First Stage Matching Chart','FontSize',15)
xlabel('W/S','FontSize',14)
ylabel('TW','FontSize',14)
sslegenda={'Take off','Climb','Cruise','Landing'};
legend(sslegenda,'Location','northeast','FontSize',12)

f=f+1;

%requisito di raggiungimento dell'orbita
z_diff=z-z_tang;
g_max=2;
a_max=g_max*g0;
R_orb=R_earth+z;
V_ss=sqrt(G_earth*M_earth/R_orb);
if z_tang<10000
    T_z_fs=T0-ht*z_tang;
else if z_tang>10001 && z_tang<20000
        T_z_fs=213;
    else if z_tang>20001 && z_tang<50000
            T_z_fs=T0+k*z;
        end
    end
end

Vs_fs=sqrt(gamma_aria*R*T_z_fs);
V_fs=Vs_fs*Mach_cruise+342;
deltaV=V_ss-V_fs;
t_burn=deltaV/a_max;
Isp=Ue/g0;
Mppl=(T_rocket*t_burn)/(Isp*g0);
Vppl=Mppl/ro_ppl;
Wr=Wss/(Wss-Mppl-W_pay_2s);
ro=1e-5;

X=(ro_f*(1+MR))/(1+(MR*(ro_f/ro_ox)));
Y=log(1+((Wr*Vppl*X)/Wss));
q=0.5*ro*V_ss^2;

prodY=Wr*Vppl*X/Wss;
rapp=(1-deltaV/(Y*g0*Isp));

Cd=0.16;

WS_orb=0:800;
TW_orb=(((q*Cd*(1+sin(gamma_orbit*pi/180)))./rapp)*(1./(WS_orb*9.81)));

%requisito di rientro
R_de=R_earth+z_de;
Vde=sqrt(G_earth*M_earth/R_de);
teta_rad=teta_grad*pi/180;
ld=z_de/(sin(teta_rad));
ro_rientro=2.3e-4;
V_av=Vde/2;

TW_reentry=linspace(0,30,6); %<------- sigma
WS_reentry=(Wss/2/(ro_rientro*Cd_rientro*ld))*(1/(V_av/Vde)^2)*ones(size(TW_reentry));

%requisito sul payload
Woe=Wss-Mppl;
Wr=Wss/Woe;

WS_pay=0:800;
K=(Wss^2)*(ro_ppl/(Wr-1))*((t_burn)/(Isp*g0*ro_ppl))*(1/Woe)*(1/(1+(W_pay_2s/Woe)));
prodotto=(1/K);
TW_pay=(1/K)*(WS_pay);

%Desing point
XD2=min(WS_lnd2s(1),WS_reentry(1));
YD2=max((1/K)*(XD2),(((q*Cd*(1+sin(gamma_orbit*pi/180)))./rapp)*(1./(XD2*9.81))));

figure(f)

plot(WS_D4,TW)
hold on
plot(WS_orb,TW_orb)
hold on
plot(WS_reentry,TW_reentry)
hold on
plot(WS_lnd2s,TW_lnd2s)
hold on
plot(WS_pay,TW_pay)
hold on 
plot(XD2,YD2,'*','MarkerSize',10,'MarkerEdgeColor','r')

title('Second Stage Matching Chart','FontSize',15)
xlabel('W/S','FontSize',14)
ylabel('TW','FontSize',14)
sslegenda={'Boundery 4','Orbit Achievement','Re-entry','Landing','Payload'};
legend(sslegenda,'Location','northeast','FontSize',12)

xlim([0 800])
ylim([0 5])

f=f+1;
